#!/bin/bash

# Assign parameters to variables
HOST=$1
USER=$2
PASSWORD=$3

for y in {2000..2023}
do
 		mkdir -p ./temp
 		wget -N "https://data.bls.gov/cew/data/files/${y}/csv/${y}_qtrly_singlefile.zip" -P ./temp
		unzip -d ./temp/ ./temp/${y}_qtrly_singlefile.zip
 		mariadb -h "$HOST" -u "$USER" -p"$PASSWORD" -e "CREATE TEMPORARY TABLE FACT_jobs.staging (GeoID varchar(5) NOT NULL, Year INT NOT NULL, own_code varchar(1) NOT NULL, Naics varchar(6) NOT NULL, Agglvl_code varchar(2) NOT NULL, size_code varchar(1) NOT NULL, Qtr varchar(1) NOT NULL, disclosure_code varchar(1), Quarterly_establishments INT, Jobs_month1 INT, Jobs_month2 INT, Jobs_month3 INT, Avg_weekly_wage INT); LOAD DATA LOCAL INFILE \"temp/${y}.q1-q4.singlefile.csv\" INTO TABLE FACT_jobs.staging FIELDS TERMINATED BY ','  ENCLOSED BY '\"' LINES TERMINATED BY '\n' IGNORE 1 LINES (@col1, @col2, @col3, @col4, @col5, @col6, @col7, @col8, @col9, @col10, @col11, @col12, @col13, @col14, @col15, @col16, @col17, @col18, @col19, @col20, @col21, @col22, @col23, @col24, @col25, @col26, @col27, @col28, @col29, @col30, @col31, @col32, @col33, @col34, @col35, @col36, @col37, @col38, @col39, @col40, @col41, @col42) SET GeoID=@col1, Year=${y}, own_code=@col2, Naics=@col3, Agglvl_code=@col4, size_code=@col5, Qtr=@col7, disclosure_code=@col8, Quarterly_establishments=@col9, Jobs_month1=@col10, Jobs_month2=@col11, Jobs_month3=@col12, Avg_weekly_wage=@col16; CREATE TEMPORARY TABLE FACT_jobs.staging2 (GeoID varchar(5) NOT NULL, Year INT NOT NULL, Naics varchar(6) NOT NULL, Agglvl_code varchar(2) NOT NULL, Qtr varchar(1) NOT NULL, Disclosure_percent DOUBLE, Quarterly_establishments INT, Jobs_month1 INT, Jobs_month2 INT, Jobs_month3 INT, Avg_weekly_wage DOUBLE); INSERT INTO FACT_jobs.staging2 SELECT GeoID, Year, Naics, Agglvl_code, Qtr, (1.0 - (CASE WHEN SUM(Quarterly_establishments) = 0 THEN 0 ELSE (SUM(CASE WHEN disclosure_code = \"N\" THEN Quarterly_establishments ELSE 0 END) / SUM(Quarterly_establishments)) END )), SUM(Quarterly_establishments), SUM(Jobs_month1), SUM(Jobs_month2), SUM(Jobs_month3), (CASE WHEN sum(Jobs_month1 + Jobs_month2 + Jobs_month3) = 0 THEN 0 ELSE sum(Avg_weekly_wage * Jobs_month1 + Avg_weekly_wage * Jobs_month2 + Avg_weekly_wage * Jobs_month3) / sum(Jobs_month1 + Jobs_month2 + Jobs_month3) END) FROM FACT_jobs.staging WHERE ((Agglvl_code > 13 AND Agglvl_code < 19) OR (Agglvl_code > 53 AND Agglvl_code < 59) OR (Agglvl_code > 73 AND Agglvl_code < 79)) AND own_code > 0 AND size_code = 0 GROUP BY GeoID, Year, Qtr, Agglvl_code, Naics; INSERT INTO FACT_jobs.QCEW (GeoID, Year, Naics, Agglvl_code, Q1_establishments, Q1_disclosure, Q1_avg_weekly_wage, Jan_jobs, Feb_jobs, Mar_jobs) SELECT GeoID, Year, Naics, Agglvl_code, Quarterly_establishments, Disclosure_percent, Avg_weekly_wage, Jobs_month1, Jobs_month2, Jobs_month3 FROM FACT_jobs.staging2 WHERE Qtr = 1 ON DUPLICATE KEY UPDATE Q1_establishments = Quarterly_establishments, Q1_disclosure = Disclosure_percent, Q1_avg_weekly_wage = Avg_weekly_wage, Jan_jobs = Jobs_month1, Feb_jobs = Jobs_month2, Mar_jobs = Jobs_month3; INSERT INTO FACT_jobs.QCEW (GeoID, Year, Naics, Agglvl_code, Q2_establishments, Q2_disclosure, Q2_avg_weekly_wage, Apr_jobs, May_jobs, Jun_jobs) SELECT GeoID, Year, Naics, Agglvl_code, Quarterly_establishments, Disclosure_percent, Avg_weekly_wage, Jobs_month1, Jobs_month2, Jobs_month3 FROM FACT_jobs.staging2 WHERE Qtr = 2 ON DUPLICATE KEY UPDATE Q2_establishments = Quarterly_establishments, Q2_disclosure = Disclosure_percent, Q2_avg_weekly_wage = Avg_weekly_wage, Apr_jobs = Jobs_month1, May_jobs = Jobs_month2, Jun_jobs = Jobs_month3; INSERT INTO FACT_jobs.QCEW (GeoID, Year, Naics, Agglvl_code, Q3_establishments, Q3_disclosure, Q3_avg_weekly_wage, Jul_jobs, Aug_jobs, Sep_jobs) SELECT GeoID, Year, Naics, Agglvl_code, Quarterly_establishments, Disclosure_percent, Avg_weekly_wage, Jobs_month1, Jobs_month2, Jobs_month3 FROM FACT_jobs.staging2 WHERE Qtr = 3 ON DUPLICATE KEY UPDATE Q3_establishments = Quarterly_establishments, Q3_disclosure = Disclosure_percent, Q3_avg_weekly_wage = Avg_weekly_wage, Jul_jobs = Jobs_month1, Aug_jobs = Jobs_month2, Sep_jobs = Jobs_month3; INSERT INTO FACT_jobs.QCEW (GeoID, Year, Naics, Agglvl_code, Q4_establishments, Q4_disclosure, Q4_avg_weekly_wage, Oct_jobs, Nov_jobs, Dec_jobs) SELECT GeoID, Year, Naics, Agglvl_code, Quarterly_establishments, Disclosure_percent, Avg_weekly_wage, Jobs_month1, Jobs_month2, Jobs_month3 FROM FACT_jobs.staging2 WHERE Qtr = 4 ON DUPLICATE KEY UPDATE Q4_establishments = Quarterly_establishments, Q4_disclosure = Disclosure_percent, Q4_avg_weekly_wage = Avg_weekly_wage, Oct_jobs = Jobs_month1, Nov_jobs = Jobs_month2, Dec_jobs = Jobs_month3;"
 		rm -r ./temp
done
