#!/bin/bash

# Assign parameters to variables
HOST=$1
USER=$2
PASSWORD=$3

for y in {2021..2022}
do
  mkdir -p ./temp
  wget -O ./temp/temp_ENT.tsv -N "https://ec.europa.eu/eurostat/api/dissemination/sdmx/3.0/data/dataflow/ESTAT/sbs_ovw_act/1.0?c[indic_sbs]=ENT_NR&c[time_period]=${y}&format=tsv"
  wget -O ./temp/temp_EMP.tsv -N "https://ec.europa.eu/eurostat/api/dissemination/sdmx/3.0/data/dataflow/ESTAT/sbs_ovw_act/1.0?c[indic_sbs]=EMP_NR&c[time_period]=${y}&format=tsv"
  wget -O ./temp/temp_LC.tsv -N "https://ec.europa.eu/eurostat/api/dissemination/sdmx/3.0/data/dataflow/ESTAT/sbs_ovw_act/1.0?c[indic_sbs]=LC_EMP_TEUR&c[time_period]=${y}&format=tsv"
  mariadb -h "$HOST" -u "$USER" -p"$PASSWORD" -e "CREATE TEMPORARY TABLE FACT_jobs.staging_ENT (Area varchar(50) NOT NULL, Value DOUBLE, Year INT); LOAD DATA LOCAL INFILE \"temp/temp_ENT.tsv\" INTO TABLE FACT_jobs.staging_ENT FIELDS TERMINATED BY '\t' LINES TERMINATED BY '\n' IGNORE 1 LINES (@col1, @col2) SET Area=@col1, Value=@col2, Year=${y}; CREATE TEMPORARY TABLE FACT_jobs.staging_EMP (Area varchar(50) NOT NULL, Value DOUBLE, Year INT); LOAD DATA LOCAL INFILE \"temp/temp_EMP.tsv\" INTO TABLE FACT_jobs.staging_EMP FIELDS TERMINATED BY '\t' LINES TERMINATED BY '\n' IGNORE 1 LINES (@col1, @col2) SET Area=@col1, Value=@col2, Year=${y}; CREATE TEMPORARY TABLE FACT_jobs.staging_LC (Area varchar(50) NOT NULL, Value DOUBLE, Year INT); LOAD DATA LOCAL INFILE \"temp/temp_LC.tsv\" INTO TABLE FACT_jobs.staging_LC FIELDS TERMINATED BY '\t' LINES TERMINATED BY '\n' IGNORE 1 LINES (@col1, @col2) SET Area=@col1, Value=@col2, Year=${y}; INSERT INTO FACT_jobs.SBS (GeoID, Year, Nace, Enterprises) SELECT SUBSTRING_INDEX(Area,',',-1), Year, SUBSTRING_INDEX(SUBSTRING_INDEX(Area,',',-3),',',1), Value FROM FACT_jobs.staging_ENT ON DUPLICATE KEY UPDATE Enterprises = Value; INSERT INTO FACT_jobs.SBS (GeoID, Year, Nace, Employment) SELECT SUBSTRING_INDEX(Area,',',-1), Year, SUBSTRING_INDEX(SUBSTRING_INDEX(Area,',',-3),',',1), Value FROM FACT_jobs.staging_EMP ON DUPLICATE KEY UPDATE Employment = Value; INSERT INTO FACT_jobs.SBS (GeoID, Year, Nace, LaborCost) SELECT SUBSTRING_INDEX(Area,',',-1), Year, SUBSTRING_INDEX(SUBSTRING_INDEX(Area,',',-3),',',1), Value FROM FACT_jobs.staging_LC ON DUPLICATE KEY UPDATE LaborCost = Value;"
  rm -r ./temp
done
