#!/bin/bash

# Assign parameters to variables
HOST=$1
USER=$2
PASSWORD=$3

declare -a state_label=("ak" "al" "ar" "az" "ca" "co" "ct" "dc" "de" "fl" "ga" "hi" "ia" "id" "il" "in" "ks" "ky" "la" "ma" "md" "me" "mi" "mn" "mo" "ms" "mt" "nc" "nd" "ne" "nh" "nj" "nm" "nv" "ny" "oh" "ok" "or" "pa" "pr" "sc" "sd" "tn" "tx" "ut" "va" "vt" "wa" "wi" "wv" "wy")
for y in {2002..2021}
do
	for i in "${state_label[@]}"
	do
   		mkdir -p ./temp
   		wget -N "https://lehd.ces.census.gov/data/lodes/LODES8/${i}/wac/${i}_wac_S000_JT00_${y}.csv.gz" -P ./temp
   		FILE=./temp/${i}_wac_S000_JT00_${y}.csv
		if [ -f "${FILE}.gz" ]; then
     			gunzip $FILE.gz
     			mariadb -h "$HOST" -u "$USER" -p"$PASSWORD" -e "LOAD DATA LOCAL INFILE '$FILE' INTO TABLE FACT_jobs.LODES8 FIELDS TERMINATED BY ',' LINES TERMINATED BY '\n' IGNORE 1 LINES (@col1, @col2, @col3, @col4, @col5, @col6, @col7, @col8, @col9, @col10, @col11, @col12, @col13, @col14, @col15, @col16, @col17, @col18, @col19, @col20, @col21, @col22, @col23, @col24, @col25, @col26, @col27, @col28, @col29, @col30, @col31, @col32, @col33, @col34, @col35, @col36, @col37, @col38, @col39, @col40, @col41, @col42, @col43, @col44, @col45, @col46, @col47, @col48, @col49, @col50, @col51, @col52, @col53) set GeoID=@col1,Year=${y},CNS01=@col9, CNS02=@col10, CNS03=@col11, CNS04=@col12, CNS05=@col13, CNS06=@col14, CNS07=@col15, CNS08=@col16, CNS09=@col17, CNS10=@col18, CNS11=@col19, CNS12=@col20, CNS13=@col21, CNS14=@col22, CNS15=@col23, CNS16=@col24, CNS17=@col25, CNS18=@col26, CNS19=@col27, CNS20=@col28;"
   		fi
   		rm -r ./temp
	done
done
